// Put the names of all group members here 
//
// all function which require editing are marked TODO


#include <GL/freeglut.h>
#include <math.h>
#include <iostream>


using namespace std;

// some global variables and their initial values:
bool wireframe_mode = false;
int number_of_slices = 20;
int number_of_stacks = 30;


//!TODO Assignment 1
void drawSphere(const float r, const int slices, const int stacks)
{
    // create vertices and faces for a sphere using the
    // OpenGL immediate mode

}

void initGL()
{
    glClearColor(1,1,1,0);   // set the clear color to black
    glEnable(GL_DEPTH_TEST); // turn on the depth test


    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluLookAt(-50, 50,-50,      // eye position in world coordinates
               50,-50, 50,      // lookat position in world coordinates
                0,  1,  0);     // up vector - y is up
}

//!TODO
void reshape(int w, int h)
{
    // set the viewport and the projection matrix.here
  
}


//________________________________________________
// you do not need to edit below this line, but
// feel free to do so and to try different things.

void display()
{
    glClearColor(0.1, 0.1, 0.2, 1.f);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glColor3f(0.9,0.9,0); // set the color to yellow
    drawSphere(25,number_of_slices,number_of_stacks);

    glFlush();
}


// the keyboard handler:
// p: toggle wireframe mode
// 1: decrease number of slices
// 2: increase number of slices
// 3: decrease number of stacks
// 4: increase number of stacks

void keyboard(unsigned char key, int x, int y) {
  
  switch(key)
  {
    case 'p': // toggle polygon mode:
      wireframe_mode = !wireframe_mode;
      if (wireframe_mode)
      {
          glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);  // set to line mode
      }
      else
      {
          glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);  // set to solid mode
      }
      break;
    
    case '1': // decrease number of slices:
      if (number_of_slices > 2)
      {
        number_of_slices--;
        cout << "slices: " << number_of_slices << endl;
      }
      else
      {
          cout << "slices already minimum!\n";
      }
      break;
      
    case '2': // increase number of slices:
      number_of_slices++;
      cout << "slices: " << number_of_slices << endl;
      break;
    
    case '3': // decrease number of stacks:
      if (number_of_stacks > 3)
      {
            number_of_stacks--;
            cout << "stacks: " << number_of_stacks << endl;
      }
      else
      {
          cout << "stacks already at minimum!\n";
      }
      break;
    
    case '4': // increase number of stacks:
      number_of_stacks++;
      cout << "stacks: " << number_of_stacks << endl;
      break;

    case 'q':
      glutLeaveMainLoop();
      break;
  }
  
  glutPostRedisplay();	
}


int main(int argc, char **argv)
{
  
  glutInit(&argc, argv);
  glutInitWindowSize(1042, 1024);
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH);
	
  glutCreateWindow("Planet System");
	
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);
  glutReshapeFunc(reshape);
	
  initGL();
	
  glutMainLoop();
}
